Redmine - Defect #42233

Float custom values with ',’ as decimal separator are not converted to '.' and cause SQL errors when

sorting or summing
2025-02-06 20:48 - Grischa Zengel

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Custom fields Estimated time: 0.00 hour
Target version: 6.0.4

Resolution: Fixed Affected version: 6.0.3
Description

If using german language settings redmine shows value 1.5 as 1,5.

You can put 1,5 to a numeric field. Redmine shows this a 1,0 on overview.

In tables, if you sort a field with this value you get error 500.

If you want a sum over this field you get error 500, too.

With english language settings it's not possible to put 1,5 to a numeric field.

Related issues:

Related to Redmine - Feature #22024: Support localized decimal separators for... Closed
Has duplicate Redmine - Defect #42330: Custom Floating Point Field Truncating... Closed

Associated revisions

Revision 23495 - 2025-02-08 07:42 - Go MAEDA

Fix: Float custom values with ', as decimal separator are not converted to "' and cause SQL errors when sorting or summing (#42233).

Patch by Go MAEDA (user:maeda).

Revision 23501 - 2025-02-09 22:59 - Go MAEDA
Merged r23495 from trunk to 6.0-stable (#42233).

History

#1 - 2025-02-07 03:48 - Go MAEDA

- Related to Feature #39997: Add an option to render values of Integer- and Float-format custom fields with thousands delimiters added

#2 - 2025-02-07 03:59 - Go MAEDA

- Related to Feature #22024: Support localized decimal separators for float values added

#3 - 2025-02-07 05:25 - Go MAEDA

- Related to deleted (Feature #39997: Add an option to render values of Integer- and Float-format custom fields with thousands delimiters)

#4 - 2025-02-07 06:55 - Go MAEDA
- File 42233.patch added
- Status changed from New to Confirmed

- Target version set to Candidate for next minor release

Thank you for reporting this issue. The problem occurs because, when using German language settings, Redmine allows the input of 1,5 (with a
comma as the decimal separator) into numeric fields. However, this value is not properly converted to 1.5 (with a period as the decimal separator)
before being saved in the custom_values table. As a result, the value remains as 1,5 in the database, causing errors during sorting or summation.

| have wroate a patch to address this issue. Once applied, the patch ensures that any new input like 1,5 is correctly converted to 1.5 before being
saved to the database. However, please note that this patch does not automatically fix existing data that has already been saved with a comma as the

decimal separator.

To correct existing data, you can do one of the following:

1. Open the issue edit page, manually change the decimal separator from °," to *." in the custom field value, and save the issue.
2. Apply the patch, then open the issue edit page and save it without making any changes. This will update the value to use a period as the decimal
separator.

#5 - 2025-02-07 07:31 - Go MAEDA

- Subject changed from Query::Statementinvalid: PG::InvalidTextRepresentation: ERROR: invalid input syntax for type numeric: ",5" to Float custom
values with '," as decimal separator are not converted to "' and cause SQL errors when sorting or summing

- Category set to Custom fields

- Target version changed from Candidate for next minor release to 6.0.4
Setting the target version to 6.0.4.
#6 - 2025-02-07 19:03 - Grischa Zengel

| patched my Redmine and it's working. Thanks for it.

It's different to time entries. If | edit an existing time entry it will show me a comma in the hours field.
| can put point or comma and it shows everywhere a comma.

For user fields | can put comma or point. It shows me everywhere a comma except if | edit this field, it will show me a point.

#7 - 2025-02-08 07:06 - Go MAEDA

Grischa Zengel wrote in #note-6:

| patched my Redmine and it's working. Thanks for it.

Thank you for your feedback.

It's different to time entries. If | edit an existing time entry it will show me a comma in the hours field.
| can put point or comma and it shows everywhere a comma.

For user fields | can put comma or point. It shows me everywhere a comma except if | edit this field, it will show me a point.

| will handle this in a new issue.

#8 - 2025-02-08 07:42 - Go MAEDA
- Status changed from Confirmed to Resolved
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix in r23495.

#9 - 2025-02-09 23:00 - Go MAEDA

- Status changed from Resolved to Closed

Merged the fix into the 6.0-stable branch in r23501.

#10 - 2025-03-24 10:50 - Go MAEDA
- Has duplicate Defect #42330: Custom Floating Point Field Truncating Decimal Part added

Files

42233.patch 2.59 KB 2025-02-07 Go MAEDA
